# Making Requests

By default, Oxylabs proxies and Proxy Rotator use a basic [**HTTP authentication**](https://en.wikipedia.org/wiki/Basic_access_authentication) that requires you to provide a username and password. You can get your credentials by contacting your Dedicated Account Manager or our Support Team at [**support@oxylabs.io**](mailto:support@oxylabs.io).

We also support authentication based on whitelisted IP addresses; see [**Whitelisting IPs**](/products/proxies/dedicated-datacenter-proxies/enterprise/whitelisting-ips.md). Depending on your authentication method, you might need to change the proxy port.

| Proxy Port | Usage                                                                                                                                                                                                                                                                      |
| ---------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `60000`    | This port is required with proxies when login credentials are used (username and password). It is also used with [**Proxy Rotator** ](/products/proxies/dedicated-datacenter-proxies/enterprise/proxy-rotator-optional.md)with both login credentials and whitelisted IPs. |
| `65432`    | Required with proxies when authorization is done via whitelisted IPs.                                                                                                                                                                                                      |

#### Code examples

If you want to use Dedicated Datacenter Proxies via username and password authentication method:

{% tabs %}
{% tab title="cURL" %}

```shell
curl -x 1.2.3.4:60000 -U user1:pass1 http://ip.oxylabs.io/location
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php
    $username = 'user1';
    $password = 'pass1';
    $proxy = '1.2.3.4:60000';
    $query = curl_init('https://ip.oxylabs.io/location');
    curl_setopt($query, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($query, CURLOPT_PROXY, "http://$proxy");
    curl_setopt($query, CURLOPT_PROXYUSERPWD, "$username:$password");
    $output = curl_exec($query);
    curl_close($query);
    if ($output)
        echo $output;
?>
```

{% endtab %}

{% tab title="Python" %}

```python
import requests

response = requests.get(
    'https://ip.oxylabs.io/location',
    proxies={'http': 'http://username:password@1.2.3.4:60000',
            'https': 'http://username:password@1.2.3.4:60000'}
)
print(response.text)
```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Net;

class Example
{
    static void Main()
    {
        var proxy = new WebProxy
        {
            Address = new Uri($"http://1.2.3.4:60000"),
            BypassProxyOnLocal = false,
            UseDefaultCredentials = false,
            Credentials = new NetworkCredential("username", "password")
        };

        var handler = new HttpClientHandler
        {
            Proxy = proxy,
        };

        HttpClient client = new HttpClient(handler);
        var task = Task.Run(async () =>
        {
            var response = await client.GetAsync("https://ip.oxylabs.io/location");
            var content = response.Content;
            var result = await content.ReadAsStringAsync();
            return result;
        });

        task.Wait();
        Console.WriteLine(task.Result);
    }
}
```

{% endtab %}
{% endtabs %}

If you want to use Dedicated Datacenter Proxies via Whitelisted IP authentication method:

{% tabs %}
{% tab title="cURL" %}

```shell
curl -x 1.2.3.4:65432 https://ip.oxylabs.io/location 
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php
    $proxy = '1.2.3.4:65432';
    $query = curl_init('https://ip.oxylabs.io/location');
    curl_setopt($query, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($query, CURLOPT_PROXY, "http://$proxy");
    $output = curl_exec($query);
    curl_close($query);
    if ($output)
        echo $output;
?>
```

{% endtab %}

{% tab title="Python" %}

```python
import requests

response = requests.get(
    'https://ip.oxylabs.io/location',
    proxies={'http': 'http://1.2.3.4:65432',
            'https': 'http://1.2.3.4:65432'}
)
print(response.text)
```

{% endtab %}

{% tab title="C#" %}

```csharp
using System;
using System.Net;

class Example
{
    static void Main()
    {
        var proxy = new WebProxy
        {
            Address = new Uri($"http://1.2.3.4:65432"),
            BypassProxyOnLocal = false,
            UseDefaultCredentials = false,
        };

        var handler = new HttpClientHandler
        {
            Proxy = proxy,
        };

        HttpClient client = new HttpClient(handler);
        var task = Task.Run(async () =>
        {
            var response = await client.GetAsync("https://ip.oxylabs.io/location");
            var content = response.Content;
            var result = await content.ReadAsStringAsync();
            return result;
        });

        task.Wait();
        Console.WriteLine(task.Result);
    }
}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://developers.oxylabs.io/products/proxies/dedicated-datacenter-proxies/enterprise/making-requests.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
